package com.example.scandemo;

import android.annotation.SuppressLint;
import android.os.Build;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.MediaPlayer;
import android.os.Vibrator;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.EditText;
import android.hardware.ScanDevice;

import java.lang.reflect.Method;

public class MainActivity extends AppCompatActivity {

    private ScanDevice				mScanDevice;
    private MediaPlayer				mmediaplayer;
    private Vibrator					mvibrator;
    private EditText showScanResult;
    EditText mtime;


    private BroadcastReceiver mScanDataReceiver = new BroadcastReceiver() {

        @Override
        public void onReceive(Context context, Intent intent) {
            // TODO Auto-generated method stub
            String action = intent.getAction();
            if (action.equals("ACTION_BAR_SCAN")) {
                String str = intent.getStringExtra("EXTRA_SCAN_DATA");
                if(str != null){
                    mmediaplayer.start();
                    mvibrator.vibrate(150);
                }
                showScanResult.append(str);
            }
        }
    };



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        mScanDevice = new ScanDevice(this);  //初始化接口  Initialization interface
        mvibrator = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE); // motor
        mmediaplayer = new MediaPlayer(); //   Initialize sound
        mmediaplayer = MediaPlayer.create(this, R.raw.scanok);
        mmediaplayer.setLooping(false);

        showScanResult = (EditText) findViewById(R.id.editText1);
        mtime = (EditText) findViewById(R.id.time);


    }


    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.openScanner:
                mScanDevice.openScan();  //Power on
                break;
            case R.id.closeScanner:
                mScanDevice.closeScan(); // Power off
                break;
            case R.id.startDecode:
                mScanDevice.startScan(); //open scan
                break;
            case R.id.stopDecode:
                mScanDevice.stopScan(); // stop scan
                break;
            case R.id.start_continue:
                mScanDevice.ContinousStart();  //open continued scanner
                break;
            case R.id.stop_continue:
                mScanDevice.ContinousStop();//close  continued scanner
                break;
            case R.id.close:
                finish();
                break;
            case R.id.ceanl:
                showScanResult.setText("");
                break;
           /* case R.id.scan_time:  //
                int time = Integer.parseInt(mtime.getText().toString());
                if(time > 30) {

                    mScanDevice.TimeScan(time);

                }*/

            default:
                break;
        }
    }


    //  Monitor Scan Key
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {

        switch (keyCode) {
            case KeyEvent.KEYCODE_F4:
                // scanning
                if (event.getRepeatCount() == 0) {
                    mScanDevice.startScan();
                }
                return true;
        }

        return super.onKeyDown(keyCode, event);
    }

    //
    @Override
    protected void onPause() {
        // TODO Auto-generated method stub
        super.onPause();

            if (mScanDevice != null) {
                mScanDevice.stopScan();
        }
        unregisterReceiver(mScanDataReceiver);
    }


    // Registered Data Broadcasting
    @Override
    protected void onResume() {
        // TODO Auto-generated method stub
        IntentFilter scanDataIntentFilter = new IntentFilter();
        scanDataIntentFilter.addAction("ACTION_BAR_SCAN");
        registerReceiver(mScanDataReceiver, scanDataIntentFilter);
        super.onResume();
    }


    @Override
    protected void onDestroy(){
        super.onDestroy();

        if (mScanDevice != null) {
            mScanDevice.closeScan();
            mScanDevice = null;
            mmediaplayer.release();
        }

    }


}